Name:           ros-jazzy-transmission-interface
Version:        4.32.0
Release:        1%{?dist}
Summary:        ROS package transmission-interface

License:        Apache License 2.0
URL:            http://www.ros.org/

Source0:        https://github.com/ros2-gbp/ros2_control-release/archive/release/jazzy/transmission_interface/4.32.0-1.tar.gz#/ros-jazzy-transmission-interface-4.32.0-source0.tar.gz



# common BRs
BuildRequires: patchelf
BuildRequires: coreutils
BuildRequires: cmake
BuildRequires: gcc-c++
BuildRequires: git
BuildRequires: make
BuildRequires: patch
BuildRequires: python3-devel
BuildRequires: python-unversioned-command
BuildRequires: python3-colcon-common-extensions
BuildRequires: python3-pip
BuildRequires: python3-pydocstyle
BuildRequires: python3-pytest
BuildRequires: python3-pytest-repeat
BuildRequires: python3-pytest-rerunfailures
BuildRequires: python3-rosdep
BuildRequires: python3-setuptools
BuildRequires: python3-vcstool

# BuildRequires:  boost-devel
# BuildRequires:  console-bridge-devel
# BuildRequires:  gtest-devel
# BuildRequires:  log4cxx-devel
# BuildRequires:  python3-devel
# BuildRequires:  python3-colcon-common-extensions
# BuildRequires:  python-unversioned-command

BuildRequires:  fmt-devel
BuildRequires:  poco-devel
BuildRequires:  tinyxml-devel
BuildRequires:  tinyxml2-devel
BuildRequires:  ros-jazzy-ament-cmake
BuildRequires:  ros-jazzy-ament-cmake-gen-version-h
BuildRequires:  ros-jazzy-ament-package
BuildRequires:  ros-jazzy-hardware-interface
BuildRequires:  ros-jazzy-pluginlib
BuildRequires:  ros-jazzy-ros2-control-cmake

Requires:       ros-jazzy-hardware-interface
Requires:       ros-jazzy-pluginlib

Requires:       ros-jazzy-ament-cmake
Requires:       ros-jazzy-ament-cmake-gen-version-h
Requires:       fmt-devel
Requires:       poco-devel
Requires:       tinyxml-devel
Requires:       tinyxml2-devel
Requires:       ros-jazzy-ament-package
Requires:       ros-jazzy-hardware-interface
Requires:       ros-jazzy-pluginlib
Requires:       ros-jazzy-ros2-control-cmake

Provides:  ros-jazzy-transmission-interface = 4.32.0-1
Obsoletes: ros-jazzy-transmission-interface < 4.32.0-1


%description
data structures for representing mechanical transmissions, methods for
propagating values between actuator and joint spaces and tooling to
support this.




%prep

%setup -c -T
tar --strip-components=1 -xf %{SOURCE0}

%build
# nothing to do here


%install

PYTHONUNBUFFERED=1 ; export PYTHONUNBUFFERED
GZ_BUILD_FROM_SOURCE=1; export GZ_BUILD_FROM_SOURCE
export GZ_VERSION=harmonic;

CFLAGS=" -Wno-error ${CFLAGS:-%optflags} -Wno-error -w -Wno-error=int-conversion" ; export CFLAGS ; \
CXXFLAGS=" -Wno-error ${CXXFLAGS:-%optflags} -Wno-error -w -Wno-error=int-conversion" ; export CXXFLAGS ; \
FFLAGS=" -Wno-error ${FFLAGS:-%optflags%{?_fmoddir: -I%_fmoddir}} -w -Wno-error=int-conversion" ; export FFLAGS ; \
FCFLAGS="${FCFLAGS:-%optflags%{?_fmoddir: -I%_fmoddir}} -w -Wno-error=int-conversion" ; export FCFLAGS ; \
%{?__global_ldflags:LDFLAGS="${LDFLAGS:-%__global_ldflags}" ; export LDFLAGS ;} \

source %{_libdir}/ros-jazzy/setup.bash

# substitute shebang before install block because we run the local catkin script
%py3_shebang_fix .

# DESTDIR=%{buildroot} ; export DESTDIR

colcon \
  build \
  --merge-install \
  --cmake-args -DPYTHON_EXECUTABLE="/usr/bin/python" \
  -DTHIRDPARTY_Asio=ON \
  -DCMAKE_BUILD_TYPE=RelWithDebInfo \
  -DCMAKE_CXX_FLAGS="$CXXFLAGS" \
  -DCMAKE_C_FLAGS="$CFLAGS" \
  -DCMAKE_LD_FLAGS="$LDFLAGS" \
  -DBUILD_TESTING=OFF \
  -Dgz_add_get_install_prefix_impl_OVERRIDE_INSTALL_PREFIX_ENV_VARIABLE="%{_libdir}/ros-jazzy/opt/" \
  --base-paths . \
  --install-base %{buildroot}/%{_libdir}/ros-jazzy/ \
  --packages-select transmission_interface



# remove wrong buildroot prefixes
# find %{buildroot}/%{_libdir}/ros-jazzy/ -type f -exec sed -i "s:%{buildroot}::g" {} \;
# we should exclude binaries from that as it might corrupt shared libraries
find %{buildroot}/%{_libdir}/ros-jazzy/ -type f ! -name '*.so*' -exec sh -c 'file "{}" | grep -q text && sed -i "s:%{buildroot}::g" "{}"' \;

# # Move include directory if source path exists
# if [ -d %{buildroot}/%{_libdir}/ros-jazzy/opt/transmission_interface/include ]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros-jazzy/include/transmission_interface ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros-jazzy/include/transmission_interface
#     fi
#     # Move the directory
#     cp -r %{buildroot}/%{_libdir}/ros-jazzy/opt/transmission_interface/include/* %{buildroot}/%{_libdir}/ros-jazzy/include/transmission_interface/
#     rm -rd %{buildroot}/%{_libdir}/ros-jazzy/opt/transmission_interface/include
# fi

# if [ -d %{buildroot}/%{_libdir}/ros-jazzy/opt/transmission_interface/extra_cmake ]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros-jazzy/transmission_interface/extra_cmake ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros-jazzy/transmission_interface/extra_cmake
#     fi
#     # Move the directory
#     cp -r %{buildroot}/%{_libdir}/ros-jazzy/opt/transmission_interface/extra_cmake/* %{buildroot}/%{_libdir}/ros-jazzy/transmission_interface/extra_cmake/
#     rm -rd %{buildroot}/%{_libdir}/ros-jazzy/opt/transmission_interface/extra_cmake
# fi

# if [ -d %{buildroot}/%{_libdir}/ros-jazzy/transmission_interface/share ]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros-jazzy/share/transmission_interface ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros-jazzy/share/transmission_interface
#     fi
#     # Move the directory
#     cp -r %{buildroot}/%{_libdir}/ros-jazzy/transmission_interface/share/* %{buildroot}/%{_libdir}/ros-jazzy/share/transmission_interface/
#     rm -rd %{buildroot}/%{_libdir}/ros-jazzy/transmission_interface/share
# fi

# # Move other opt path if source path exists
# if [ -d %{buildroot}/%{_libdir}/ros-jazzy/opt/transmission_interface]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros-jazzy ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros-jazzy
#     fi
#     # Move the directory
#     cp -r %{buildroot}/%{_libdir}/ros-jazzy/opt/transmission_interface/* %{buildroot}/%{_libdir}/ros-jazzy/
#     rm  -rd %{buildroot}/%{_libdir}/ros-jazzy/opt/transmission_interface
# fi

rm -rf %{buildroot}/%{_libdir}/ros-jazzy/{.catkin,.rosinstall,_setup*,local_setup*,setup*,env.sh,.colcon_install_layout,COLCON_IGNORE,_local_setup*,_local_setup*}

# vendor pkg removal
rm -rf %{buildroot}/%{_libdir}/ros-jazzy/opt/share/transmission_interface/{.catkin,.rosinstall,_setup*,local_setup*,setup*,env.sh,.colcon_install_layout,COLCON_IGNORE,_local_setup*,_local_setup*}

# remove __pycache__
find %{buildroot} -type d -name '__pycache__' -exec rm -rf {} +
find . -name '*.pyc' -delete

touch files.list
find %{buildroot}/%{_libdir}/ros-jazzy/{share,bin,etc,tools,lib64/python*,lib/python*/site-packages,lib/python*/dist-packages} \
  ! -name cmake ! -name include \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" > files.list
find %{buildroot}/%{_libdir}/ros-jazzy/lib*/ -mindepth 1 -maxdepth 1 \
  ! -name pkgconfig ! -name "python*" \
  | sed "s:%{buildroot}/::" >> files.list

# paths for vendor packages
find %{buildroot}/%{_libdir}/ros-jazzy/transmission_interface/{bin,etc,tools,lib64/python*,lib/python*/site-packages,share} \
  ! -name cmake ! -name include \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-jazzy/opt/transmission_interface/{bin,etc,tools,lib64/python*,lib/python*/site-packages,share} \
  ! -name cmake ! -name include \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-jazzy/transmission_interface/lib*/ -mindepth 1 -maxdepth 1 \
  ! -name pkgconfig ! -name "python*" \
  | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-jazzy/opt/transmission_interface/lib*/ -mindepth 1 -maxdepth 1 \
  ! -name pkgconfig ! -name "python*" \
  | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-jazzy/opt/share/transmission_interface \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list

find %{buildroot}/%{_libdir}/ros-jazzy/{lib*/pkgconfig,include/,cmake/,transmission_interface/include/,share/transmission_interface/cmake} \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
# paths for vendor packages
find %{buildroot}/%{_libdir}/ros-jazzy/transmission_interface/{lib*/pkgconfig,include/,cmake/,extra_cmake/,transmission_interface/include/,share/cmake} \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-jazzy/opt/transmission_interface/extra_cmake \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-jazzy/opt/transmission_interface/{lib*/pkgconfig,include/,cmake/,transmission_interface/include/,/share/cmake,/extra_cmake} \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-jazzy/opt/share/ament_index/resource_index \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-jazzy/opt/share/colcon-core/packages/ \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-jazzy/opt/share/transmission_interface/{hook,environment,cmake} \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find . -maxdepth 1 -type f -iname "*license*" | sed "s:^:%%license :" >> files.list



find %{buildroot}/%{_libdir}/ros-jazzy/ -name *__rosidl_generator_py.so -type f -exec patchelf --remove-rpath  {} \;
# find %{buildroot}/%{_libdir}/ros-jazzy/ -name *__rosidl_generator_py.so -type f -exec patchelf --force-rpath --add-rpath "%{_libdir}/ros2/lib" {} \;
find %{buildroot}/%{_libdir}/ros-jazzy/ -name "*.so*" -type f -exec patchelf  --shrink-rpath --allowed-rpath-prefixes %{_libdir} {} \;

# replace cmake python macro in shebang
for file in $(grep -rIl '^#!.*@PYTHON_EXECUTABLE@.*$' %{buildroot}) ; do
  sed -i.orig 's:^#!\s*@PYTHON_EXECUTABLE@\s*:%{__python3}:' $file
  touch -r $file.orig $file
  rm $file.orig
done


echo "This is a package automatically generated with rosfed." >> README_FEDORA
echo "See  https://github.com/TarikViehmann/rosfed for more information." >> README_FEDORA
install -m 0644 -p -D -t %{buildroot}/%{_docdir}/%{name} README_FEDORA
echo %{_docdir}/%{name} >> files.list

%py3_shebang_fix %{buildroot}

# Also fix .py.in files
for pyfile in $(grep -rIl '^#!.*python.*$' %{buildroot}) ; do
  %py3_shebang_fix $pyfile
done

sort files.list | uniq > files.list.tmp && mv files.list.tmp files.list

%files -f files.list


%changelog
* Sat Jun 28 2025 Tarik Viehmann <viehmann@kbsg.rwth-aachen.de> - jazzy.4.32.0-1
- Update to latest release
* Tue May 13 2025 Tarik Viehmann <viehmann@kbsg.rwth-aachen.de> - jazzy.4.29.0-1
- Update to latest release
* Wed Apr 30 2025 Tarik Viehmann <viehmann@kbsg.rwth-aachen.de> - jazzy.4.28.1-1
- Update to latest release
* Fri Apr 18 2025 Tarik Viehmann <viehmann@kbsg.rwth-aachen.de> - jazzy.4.28.0-1
- Update to latest release
